/*
 Citim o matrice de litere (n linii, m coloane) shi un cuvint.

 Sa determinam TOATE aparitziile cuvintului in matrice, shtiind ca NU avem voie
sa alegem de 2 ori aceeashi litera shi de asemenea ca avem voie sa ne deplasam
st-dr-sus-jos shi pe diagonale.

  vom afisha matricea parcurgerii shi drumul
Ex:
n=6 m=8
W	U	R	I	Z	P	Y	E
W	Q	S	Z	O	C	C	M
B	C	E	S	E	B	E	I
F	Y	H	L	F	I	S	S
P	A	J	U	N	A	H	S
U	O	U	P	N	Q	N	T
shi s="ELEFANT"
0   0   0   0   0   0   0   0
0   0   0   0   0   0   0   0
0   0   1   0   3   0   0   0
0   0   0   2   4   0   0   0
0   0   0   0   0   5   0   0
0   0   0   0   0   0   6   7
(3,3) (4,4) (3,5) (4,5) (5,6) (6,7) (6,8)
*/

#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>

using namespace std;

char lit[30][30],s[30];
int n,m,a[30][30];
struct drum {int l,c;} d[30];

void afish(int k)
{
  int i,j;
    for(i=1;i<=n;i++)
       {for(j=1;j<=m;j++)
          cout<<setw(3)<<a[i][j];
        cout<<"\n";
       }
    for(i=1;i<=k;i++) cout<<"("<<d[i].l<<","<<d[i].c<<") ";
    cout<<"\n---------------------------------------------------\n";
}

void back(int i,int j,int k)
{
    if(1<=i&&i<=n&&1<=j&&j<=m)
        if(a[i][j]==0&&lit[i][j]==s[k-1])
           {
               a[i][j]=k;d[k].l=i;d[k].c=j;
               if(k==strlen(s))
                          afish(k);
                else {//cele 8 apeluri recursive:
                       int di,dj;
                       for(di=-1;di<=1;di++)
                          for(dj=-1;dj<=1;dj++)
                              if(di!=0||dj!=0)
                                   back(i+di,j+dj,k+1);
                      }
                a[i][j]=0;
           }
}

int main()
{
    ifstream fin("apl01.in");
    fin>>n>>m;
    int i,j;
    for(i=1;i<=n;i++)
      for(j=1;j<=m;j++)
          fin>>lit[i][j];
    fin.get();
    fin.get(s,30);
    memset(a,0,sizeof(a));
    for(i=1;i<=n;i++)
      for(j=1;j<=m;j++)
         back(i,j,1);
    return 0;
}
