#include<fstream.h>
#include<math.h>

#define dmax 6501
#define inf 60000.0
#define numein "cablaj.in"
#define numeout "cablaj.out"


struct pct {int x,y;} a[dmax];
float d[dmax];
int n;
char viz[dmax];

float dist(pct a,pct b)
{
 return sqrt( ((long)a.x-b.x)*((long)a.x-b.x)+
	      ((long)a.y-b.y)*((long)a.y-b.y));
}

void main()
{
 ifstream fin(numein);
 fin>>n;
 int i,j;
 for(i=1;i<=n;i++)
   {
    fin>>a[i].x>>a[i].y;
    viz[i]=0;
    d[i]=dist(a[i],a[1]);
   }
 fin.close();
 viz[1]=1;
 float dmin;
 int jmin;
 for(i=1;i<=n-2;i++)
  {
    dmin=inf;
    for(j=1;j<=n;j++)
       if(!viz[j]&&d[j]<dmin) dmin=d[jmin=j];
    viz[jmin]=1;
    for(j=1;j<=n;j++)
       {
	dmin=dist(a[jmin],a[j]);
	if(!viz[j] && dmin<d[j]) d[j]=dmin;
       }
  }
 float dtot=0;
 for(j=1;j<=n;j++) dtot+=d[j];
 ofstream fout(numeout);
 fout<<dtot<<"\n";
 fout.close();
}