
#include <stdio.h>
#include <vector>

using namespace std;

const int inf = 1000000000;
vector<int> v( 100000+1, 0 );
int D, I, P;
int N, M, H;
int h_min=0, h_max=0;

void citire() {

   scanf( "%d%d%d%d%d ", &D, &I, &P, &N, &M );
   for( int i = 1; i <= N; ++i ) {
      char c;
      scanf( "%c", &c );
      if( c == 'J' ) v[i] = v[i-1] - 1;
      if( c == 'O' ) v[i] = v[i-1];
      if( c == 'S' ) v[i] = v[i-1] + 1;
      h_min <?= v[i];
      h_max >?= v[i];
   }
}

int dinamica() {
vector< int > nivele( H+1, -1 );
   vector< int > drum( N+1, -1 );

   for( int i = 0; i <= N; ++i ) {
      if( i > 0 && v[i] != v[i-1] && nivele[v[i]] != -1 )
         drum[nivele[v[i]]] = i;
      nivele[v[i]] = i;
   }

   vector< int > a[2];
   a[0] = a[1] = vector<int> (N+1, inf);
   a[0][0] = 0;

   int minim = inf;
   for( int K = 0; K <= M; ++K ) {
      int k = K%2;
      int kplus1 = (K+1)%2;

      for( int x = 0; x <= N; ++x ) a[kplus1][x] = inf;
      for( int x = 0; x < N; ++x ) {
         if( v[x+1] == v[x]+1 ) a[k][x+1] <?= a[k][x] + I;
         if( v[x+1] == v[x]   ) a[k][x+1] <?= a[k][x] + D;
         if( v[x+1] == v[x]-1 ) a[k][x+1] <?= a[k][x] + I;
         if( drum[x] != -1 ) a[kplus1][drum[x]] <?= a[k][x] + P*(drum[x]-x);
      }
      minim <?= a[k][N];
   }
   return minim;
}
int main( void ) {
    freopen("lemmings.in", "r", stdin);
    freopen("lemmings.out", "w", stdout);
    citire();
   for( int i = 0; i <= N; ++i ) v[i] -= h_min;
   H = h_max-h_min;


    int x = dinamica();
   printf( "%lf\n", x/10. );

   return 0;
}
