/*
  Dificultatea acestei probleme consta in faptul ca dimensiunile matricei
pot fi f. mari (100 linii shi col.) shi in acest fel este posibil ca produsul
elem. de pe o coloana sa atinga 2^100, ce nu poate fi reprezentat not even
pe long.

  O solutzie mai neortodoxa ar fi sa folosim double, care oricum ne va
aproxima puterea lui 2, insa aproximatzia e suficient de ok.

  Solutzia cea mai la indemina pleak de la obs. k pe ficare coloana produsul
nr. poate fi:
  0  sau  1  sau o putere a lui 2.

  Ashadar, convenim ca intr-o variabila vom retzine fie 0, fie 1, fi un
nr>1 care e de fapt puterea la care apare 2, adunata cu 1.
Ex:
 dak pe o coloana avem   2 1 2 1 0 1 2 -> retzinem 0
			 1 1 1 1 1 1 1 -> retzunem 1
			 2 2 1 2 2 1 2 -> retzinem 6 (2 apare la put. a5a
						 shi retzinem put.cu pricina
						 adunata cu 1)

 Ca sa rezolv. probl. kt mai rapid, luam un shir in care memoram produsul
sub codif. de mai 'nainte.
  Apoi din shir afish. indicii care au maximul cu pricina.
*/
#include<iostream.h>
#include<conio.h>

int a[101][101],p[101];

void main()
{
 clrscr();
 int i,j,n,m,codif,avem0,nr2,max=-1;
 cout<<"Nr. de linii=";cin>>m;
 cout<<"Nr. de coloane=";cin>>n;
 cout<<"Vra elementele matricei:\n";
 for(i=1;i<=m;i++)
  for(j=1;j<=n;j++)
   cin>>a[i][j];
 //calculam codificarea produselor de pe fieshcare coloana:
 for(j=1;j<=n;j++)
   {
    avem0=0;nr2=0;
    //parcurgem coloana j:
    for(i=1;i<=m;i++)
       if(a[i][j]==0)avem0=1;
       else if(a[i][j]==2) nr2++;
    if(avem0)p[j]=0;
    else if(nr2==0) p[j]=1;
	   else p[j]=nr2+1;
    //facem tot aici shi maxu'
    if(p[j]>max) max=p[j];
   }
 //parcurgem vectorul shi afisham indicii la kre i max:
 for(j=1;j<=n;j++)
   if(p[j]==max) cout<<j<<" ";
 getch();
}
