//Varianta Doru
#include <iostream>
#include <fstream>
using namespace std;

int card_val(char c)
{
    if(c=='0') return 10;
    if(c<='9') return c-'0';
    if(c=='A') return 1;
    if(c=='J') return 12;
    if(c=='Q') return 13;
    return 14;
}

int suit_val(char c)
{
    if(c=='C') return 1;
    if(c=='D') return 2;
    if(c=='H') return 3;
    return 4;
}

int bridge_val(char *s)
{
    int hand[5][15];memset(hand,0,sizeof(hand));
    int i,j,sum=0,sum_suit;
    for(i=0;i<strlen(s);i+=2)
       hand[suit_val(s[i+1])][card_val(s[i])]=1;
    for(i=1;i<=4;i++)
       {
           sum_suit=0;
           if(hand[i][1]) sum+=4;
           if(hand[i][14]) sum+=3;
           if(hand[i][13]) sum+=2;
           if(hand[i][12]) sum+=1;
           for(j=1;j<=14;j++) sum_suit+=hand[i][j];
           if(!sum_suit) sum+=3;
           if(sum_suit==1) sum+=2;
           if(sum_suit==2) sum+=1;
       }
    if(hand[1][1]&&hand[2][1]&&hand[3][1]&&hand[4][1])sum+=1;
    return sum;
}

int moat_val(char *s)
{
    int i,sum=0,cv;
    for(i=0;i<strlen(s);i+=2)
       {
           cv=card_val(s[i]);
           if(cv==1) sum+=15;
           else if(cv>10) sum+=12;
           else sum+=cv;
       }
    return sum;
}


int main()
{
    ifstream fin("brmoat.in");
    char s[200];
    int i;
    for(i=1;i<=5;i++)
    {
        fin.get(s,200);fin.get();
        cout<<"MOAT="<<moat_val(s)<<"\n"<<
              "BRIDGE="<<bridge_val(s)<<"\n";
    }
    return 0;
}
