//Prenume, NUME: Eduard BOLOS
/*
 Scrieti un program bazat in mod esential pe recursivitate (deci in care nu
aveti voie sa scrieti nici o repetitiva, orice repetitiva fiind modelata
recursiv) in care sa cititi de la tastatura un numar natural n<100 si un
sir cu n elemente de tip int. Programul va inlocui fiecare element al
sirului cu suma primelor sale doua cifre si va afisa sirul format

 Pentru determinarea sumei primelor doua cifre ale unui numar veti scrie
o functie recursiva care primeste printr-un parametru de tip long numarul
in cauza si intoarce suma primelor doua cifre ale sale. Nu aveti voie
sa folositi in aceasta functie nici o variabila globala.
*/

#include <iostream>

using namespace std;

void citire(int a[101], int i);
void parcurge(int a[101],int i);
int suma(long nr);
void afisare(int a[101],int i);

int main()
{
    int n,a[101];
    cin>>n;
    citire(a,n);
    parcurge(a,n);
    afisare(a,n);
}

void citire(int a[101], int i)
{
    if(i)
     {
         cin>>a[i];
         citire(a,i-1);
     }
}

void parcurge(int a[101],int i)
{
    if(i)
    {
        a[i]=suma(a[i]);
        parcurge(a,i-1);
    }
}

int suma(long nr)
{
    if(nr<100)
     return nr%10+nr/10;
    return suma(nr/10);
}

void afisare(int a[101], int i)
{
    if (i)
    {
        cout<<a[i]<<" ";
        afisare(a,i-1);
    }
}
