#include <iostream>
#include <fstream>

using namespace std;

//urmatoarele doua convertesc din char in cifra coresp. (shi pt. cifre >=10)
//respectiv pe dos
int ctoi(char c)
{
    c=toupper(c);
    if(c>='A') return c-'A'+10;
    return c-'0';
}

char itoc(int i)
{
    if(i<10) return i+'0';
    return i-10+'A';
}

//facem o functzie de adunat 2 numere mari.
//pp. k numerele is retzinute in stringe
//Pentru ushurarea calculelor shi-a muncii, in stringe
//numerele is retzinute invers (ult. cifra la indicele 0,
//penultima la 1, etc.

void aduna(char n1[],char n2[],char s[],int baza)
{
    int nc1=strlen(n1),nc2=strlen(n2),i,nrez;
    //completam cu 0uri p-ala mai pici
    nrez=nc1>nc2?nc1:nc2;
    //kestia asta s.n. expr. conditzionala - vezi manualu' de-a IX-a
    for(i=nc1;i<nrez;i++) strcat(n1,"0");
    for(i=nc2;i<nrez;i++) strcat(n2,"0");
    //obs: dintre cele 2 for-uri se executa doar unul
    int cif,t=0;//t=transportul <=> cit vine de la perechea anterioara
    for(i=0;i<nrez;i++)
    {
        cif=(ctoi(n1[i])+ctoi(n2[i])+t)%baza;
        s[i]=itoc(cif);
        t=(ctoi(n1[i])+ctoi(n2[i])+t)/baza;
    }
    if(t) s[nrez++]=itoc(t);
    s[nrez]=0;
}

int ispal(char s[])
{
    char s1[100];
    strcpy(s1,s);strrev(s1);
    return strcmp(s1,s)==0;
}

int main()
{
    char s[100],n1[100],n2[100],l[256];
    int nrep,i,baza;
    ifstream fin("palindr.in");
    for(i=1;i<=5;i++)
    {
        fin.get(l,256);fin.get();
        strcpy(n1,strtok(l,", "));
        baza=atoi(strtok(NULL,", "));
        nrep=0;
        while(nrep<10 && !ispal(n1))
        {
            strcpy(n2,n1);
            strrev(n2);
            aduna(n1,n2,s,baza);
            nrep++;
            strcpy(n1,s);
        }
        strrev(n1);
        if(!ispal(n1)) cout<<"NONE, "<<n1<<"\n";
        else cout<<n1<<"\n";
    }
    return 0;
}
