#include <iostream>
#include<fstream>

using namespace std;

//In fishierul date.txt avem un shir cu valori naturale.
//Pe prima linie se gasesc toate numerele, separate prin spatzii.
//Sa cream o lista dublu inlantzuita shi sa o afisham stinga-dreapta shi
//dreapta-stinga, dupa care vom shterge din ea prima valoare care este numar par.
//Vom trata toate exceptziile cu putintza.

struct nod {
               int inf;
               nod *next,*prev;
            };
typedef nod *listad;

void lesen(listad &prim,listad &ultim)
{
    ifstream fin("date5.txt");
    //cream capu':
    prim=ultim=new nod;
    fin>>prim->inf;fin.get();
    prim->next=prim->prev=NULL;
    //le citim pe restul din fishier, pina dam de eof()
    while(!fin.eof())
    {//tot citim unu' nou shi il adaugam la coada
        ultim->next=new nod;
        ultim->next->prev=ultim;
        ultim=ultim->next;
        fin>>ultim->inf;fin.get();
        ultim->next=NULL;
    }
    fin.close();
}

void schreibenlr(listad p)//afishare de la st. la dreapta
{
    for(;p;p=p->next)
         cout<<p->inf<<" ";
    cout<<"\n";
}

void schreibenrl(listad p)//de la dreapta la stinga
{
    for(;p;p=p->prev)
         cout<<p->inf<<" ";
    cout<<"\n";
}

void erase(listad &prim,listad &ultim)
{
    //tratam exceptziile:
    //1. Cind este un unic element in lista, sh-ala e par:
    listad aux;
    if(prim==ultim&&prim->inf%2==0)
        {
            delete prim;prim=ultim=NULL;
            return;//ca sa iasa fara drept de apel
        }
    //2. Cind este primul shi este par (sigur nu e unicul, pt. k dak era,
    //intra in cazul 1:
    if(prim->inf%2==0)
       {
           aux=prim;
           prim=prim->next;
           delete aux;
           prim->prev=NULL;
           return;
       }
//3. Cind este ultimul shi este par (sigur nu e unicul, pt. k dak era,
    //intra in cazul 1:
    if(ultim->inf%2==0)
       {
           aux=ultim;
           ultim=ultim->prev;
           delete aux;
           ultim->next=NULL;
           return;
       }
//am terminat cu exceptziile: cautam adresa primului element care este par:
    listad p=prim;
    while(p && p->inf%2!=0)
                      p=p->next;
    if(p==NULL)
         {
             cout<<"In lista nu sunt elemente pare\n";
             return;
         }
    //daca n-a ieshit pe-aici, in sfirshit avem p = adresa parului.
    //sigur nu e nici primul, nici ultimul, nici unicul
    //shi il shtergem. Pentru ca adresa p NU ne mai trebuie in continuare,
    //lucram direct cu ea in shtergere:
    p->prev->next=p->next;
    p->next->prev=p->prev;
    delete p;
}

int main()
{
    listad prim,ultim;
    lesen(prim,ultim);
    cout<<"Iata lista afishata cap -> coada:\n";
    schreibenlr(prim);
    cout<<"Iata lista afishata coada -> cap:\n";
    schreibenrl(ultim);
    erase(prim,ultim);
    if(prim==NULL)
       cout<<"Era unul singur shi sh'ala par -> lista a devenit vida\n";
    else
    {
      cout<<"Lista finala afishata cap -> coada:\n";
      schreibenlr(prim);
      cout<<"Lista finala afishata coada -> cap:\n";
      schreibenrl(ultim);
    }
    return 0;
}
