#include <iostream>

using namespace std;
/*
  Lucram kt mai modular: utilizam kt mai multe functzii.

  Vom citi un shir de intzi. CAlculam cmmdc-ul la' totzi.

  Vom mai vedea o proprietate meseriasha a functziilor in C++ (care se cheama
supraincarcare): daca definim 2 functzii cu acelashi nume shi cu param. diferitzi,
C++ -ul e suficient de deshtept sa se prinda pe care dintre ele s-o apeleze, in
functzie de param. cu care facem apelul.
  Asha ca:
    * scriem o functzie int cmmdc(int a,int b) care sa calculeze cmmdc-ul celor doua numere
    * o alta functzie, tot cmmdc, care sa calculeze cmmdc-ul din tot shirul:
         int cmmdc(int *a,int n)   -> a = shirul , n= nr. dghie elemente

Obs:
  Kzuri exceptzie:
  1) pt. a!=0
      cmmdc(a,0)=cmmdc(0,a)=a
  2) cmmdc(0,0)=infinit

Obs: functzia va da 0, dac-o apelam cu 0,0 shi noi vom shti ca, de fapt,
este vorba de infinint
*/

int cmmdc(int a,int b)
{
    int r;
    while(b)
    {
        r=a%b;
        a=b;
        b=r;
    }
    return a;
}

int cmmdc(int *a,int n)//asta va calcula cmmdc-ul dintre toate elem. shirului
{//cmmdc dintre mai multe kestii se calculeaza ca shi o suma dintre mai multe kestii
    //deci dintre primele doua, apoi dintre rezultat shi-al treilea, etc.
    int rez=0,i;
    for(i=1;i<=n;i++)//vezi observatzia cu cmmdc(0,tz). Morala e k nu mai tre' sa luam
       rez=cmmdc(rez,a[i]);
    return rez;
}

int main()
{
    int a[10]={0,12,18,66,21};
    cout<<cmmdc(a,4);
    return 0;
}
